﻿package scenes{
	import assets.*;
	import flash.display.*;
	import flash.events.*;
	import flash.ui.*;
	import jp.progression.casts.*;
	import jp.progression.commands.*;
	import jp.progression.commands.display.*;
	import jp.progression.commands.lists.*;
	import jp.progression.commands.managers.*;
	import jp.progression.commands.media.*;
	import jp.progression.commands.net.*;
	import jp.progression.commands.tweens.*;
	import jp.progression.data.*;
	import jp.progression.events.*;
	import jp.progression.executors.*;
	import jp.progression.scenes.*;
	import ui.*;
	import view.Footer;
	import view.World;

	/**
	 * ルートシーン
	 * @author Yasu
	 */
	public class IndexScene extends SceneObject {
		private var _world:World;
		private var _bg:MovieClip;

		/**
		 * 新しい IndexScene インスタンスを作成します。
		 */
		public function IndexScene(){
			// シーンタイトルを設定します。
			_world = World.instance;
			_bg = new Bg();
			_footer = new Footer();

			// スライドを透過するかどうかをスイッチするメニューを追加する
			_itemA = new ContextMenuItem("落書きの消去", false);
			_itemA.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT, _menuItemSelect);
			_itemB = new ContextMenuItem("インデックスに戻る", false);
			_itemB.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT, _menuItemSelect);

			// ContextMenu を作成する
			container.contextMenu = new ContextMenu();
			container.contextMenu.customItems = [_itemA, _itemB];

			_canvas = new Canvas();
			
			// スライド枚数分だけシーンを作成する
			for (var i:int = 0, l:int = World.numSlides; i < l; i++){
				addScene(new SlideScene(i, String(i)));
			}

		}
		private var _canvas:Canvas;
		private var _itemA:ContextMenuItem;
		private var _itemB:ContextMenuItem;
		private var _footer:Footer;

		private function _menuItemSelect(e:ContextMenuEvent):void {
			switch (e.target){
				case _itemA:
					_canvas.clear();
					break;
				case _itemB:
					new Goto(new SceneId("/index")).execute();
					break;
			}
		}

		/**
		 * シーン移動時に目的地がシーンオブジェクト自身もしくは子階層だった場合に、階層が変更された直後に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneLoad():void {
			
			container.addChild(_bg);
			container.addChild(_world);
			//container.addChild(_footer);
			new AddChild(container, _footer).execute();
			new AddChild(container, _canvas).execute();
			//container.addChild(_canvas);
		}

		/**
		 * シーンオブジェクト自身が目的地だった場合に、到達した瞬間に送出されます。
		 * このイベント処理の実行中には、ExecutorObject を使用した非同期処理が行えます。
		 */
		override protected function atSceneInit():void {
			addCommand(
				_world.getMoveCarouselCommand()
				);
		}

		override protected function atSceneGoto():void {
			addCommand(
				_world.getMoveLineCommand()
				);
		}
	}
}
