package sound
{
	import caurina.transitions.SpecialProperty;
	import flash.events.Event;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;
	import flash.net.URLRequest;
	
	/**
	 * SoundManager
	 * @author Yasu (clockmaker.jp)
	 */
	public class SoundManager 
	{
		// assets
		[Embed(source = "/assets/sound/btn_click.mp3")]	private var BtnClick:Class;
		[Embed(source = "/assets/sound/btn_over.mp3")]	private var BtnOver:Class;
		
		private var btnOver:Sound;
		private var btnClick:Sound;
		
		/**
		 * play RollOver sound
		 */
		public function playBtnOverSound():void
		{
			if (_isMute) return;
			btnOver.play();
		}
		
		/**
		 * play click sound
		 */
		public function playBtnClickSound():void
		{
			if (_isMute) return;
			btnClick.play();
		}
		
		/**
		 * setter/getter for mute
		 */
		private var _isMute:Boolean;
		public function get isMute():Boolean { return _isMute; }
		public function set isMute(value:Boolean):void 
		{
			_isMute = value;
		}
		
		/**
		 * Singleton
		 */
		static private var _instance:SoundManager = new SoundManager();
		static public function get instance():SoundManager { return _instance; }
		
		/**
		 * SoundManager
		 */
		public function SoundManager() 
		{
			init();
		}
		
		/**
		 * Init
		 */
		private function init():void
		{
			btnOver = new BtnOver() as Sound;
			btnClick = new BtnClick() as Sound;
		}
	}
}