﻿package ui {
	import caurina.transitions.*;
	import flash.display.*;
	import flash.events.*;
	import jp.nium.core.debug.Logger;
	import jp.progression.casts.*;
	import jp.progression.commands.*;
	import jp.progression.commands.display.*;
	import jp.progression.commands.lists.*;
	import jp.progression.commands.net.*;
	import jp.progression.commands.tweens.*;
	import jp.progression.data.*;
	import jp.progression.events.*;
	import jp.progression.scenes.*;
	
	/**
	 * ...
	 * @author yasu
	 */
	public class Canvas extends CastSprite {
		
		// スライドを透過するかどうかを切り替える
		public function get hidden():Boolean { return _hidden; }
		public function set hidden( value:Boolean ):void {
			_hidden = value;
			
			_canvas.visible = _hidden;
		}
		private var _hidden:Boolean = true;
		
		private var _canvas:Shape;
		
		public function Canvas( initObject:Object = null ) {
			super( initObject );
			
			// 描画用のキャンバスを作成する
			_canvas = new Shape();
			
			// 画面に表示する
			addChild( _canvas );
		}
		
		override protected function atCastAdded():void {
			// イベントリスナーを登録する
			stage.addEventListener( MouseEvent.MOUSE_DOWN, _mouseDown );
			stage.addEventListener( MouseEvent.MOUSE_UP, _mouseUp );
		}
		
		override protected function atCastRemoved():void {
			addCommand(
				function():void {
					// イベントリスナーを削除する
					removeEventListener( Event.ENTER_FRAME, _enterFrame );
					stage.removeEventListener( MouseEvent.MOUSE_DOWN, _mouseDown );
					stage.removeEventListener( MouseEvent.MOUSE_UP, _mouseUp );
					
					// 画面から消去する
					removeChild( _canvas );
					
					// メモリから解放する
					_canvas = null;
				}
			);
		}
		
		private function _enterFrame( e:MouseEvent ):void {
			// キャンバスに描画する
			_canvas.graphics.lineTo( mouseX, mouseY );
			e.updateAfterEvent();
		}
		
		private function _mouseDown( e:MouseEvent ):void {
			
			if (!_hidden) return;
			
			// 描画初期位置を設定する
			_canvas.graphics.moveTo( mouseX, mouseY );
			_canvas.graphics.lineStyle( 3, 0xFF0000 );
			
			// イベントリスナーを登録する
			stage.addEventListener( MouseEvent.MOUSE_MOVE, _enterFrame );
		}
		
		private function _mouseUp( e:MouseEvent ):void {
			// イベントリスナーを削除する
			stage.removeEventListener( MouseEvent.MOUSE_MOVE, _enterFrame );
		}
		
		public function clear():void
		{
			// キャンバスをクリアする
			_canvas.graphics.clear();
		}
	}
}
